/*
Gollum Mouse (Partie Code)
Unite de gestion de la souris
Portable C++ New Version
By Gollum (c) Thunder Folks 1995-98
*/

#include "g_mouse.h"
#include <dos.h>

Souris::Souris()
{
 Actif=Init();
 Remap=1;
 Display=0;
}

Souris::~Souris()
{
 Hide();
}

int Souris::Init()
{
 union REGS R;
 R.w.ax=0x00;
 int386(0x33,&R,&R);
 return(R.w.ax==0xFFFF);
}

Souris::Show()
{
 union REGS R;
 if ((Actif)&&(!Display)&&(Remap))
 {
  R.w.ax=0x01;
  int386(0x33,&R,&R);
  Display=1;
 }
 else Remap=1;
}

Souris::Hide()
{
 union REGS R;
 if ((Actif)&&(Display))
 {
  R.w.ax=0x02;
  int386(0x33,&R,&R);
  Display=0;
  Remap=1;
 }
 else Remap=0;
}

Souris::Test()
{
 union REGS R;
 if (Actif)
 {
  R.w.ax=0x03;
  int386(0x33,&R,&R);
  Posx=R.w.cx;
  Posy=R.w.dx;
  Button=R.h.bl;
 }
}

Souris::Move(int X,int Y)
{
 union REGS R;
 if (Actif)
 {
  R.w.ax=0x04;
  R.w.cx=X;
  R.w.dx=Y;
  int386(0x33,&R,&R);
  Posx=X;
  Posy=Y;
 }
}

Souris::Fix(int Y)
{
 union REGS R;
 if (Actif)
 {
  R.w.ax=0x08;
  R.w.cx=0;
  R.w.dx=Y;
  int386(0x33,&R,&R);
 }
}

int Souris::GetX()
{
 return(Posx);
}

int Souris::GetY()
{
 return(Posy);
}

int Souris::GetBouton()
{
 return(Button);
}

